<?php
class Key {
	private $alg;
	private $key;
	private $comment;
	
	public function __construct($alg, $key, $comment = "") {
		$this->alg = $alg;
		$this->key = $key;
		$this->comment = $comment;
	}
	
	public function getAlgorithm() {
		return $this->alg;
	}
	
	public function setAlgorithm($alg) {
		$this->alg = $alg;
	}
	
	public function getAlgorithmLabel() {
		if (strcmp($this->alg,"ssh-rsa")==0) {
			return "RSA";
		}
		else if (strcmp($this->alg,"ssh-dss")==0) {
			return "DSA";
		}
		else {
			return $this->alg;
		}
	}
	
	public function getKey() {
		return $this->key;
	}
	
	public function setKey($key) {
		$this->key = $key;
	}
	
	public function getComment() {
		return $this->comment;
	}
	
	public function setComment($comment) {
		$this->comment = $comment;
	}
	
	public static function parseString($str) {
		$data = explode(" ",$str);
		$alg = $data[0];
		$key = $data[1];
		$comment = "Added at ".date("m/d/y");
		if (count($data)>2) {
			$comment = $data[2];
		}
		$res = new Key($alg, $key, $comment);
		
		return $res;
	}
}
?>