<?php
if (!isset($sshfed_folder)) {
	require_once("../../config.php");
}

/*
	<SSHServer host="localhost" port="22">
		<WebService address="http://localhost:8888/sshfed_ws/" />
		<Policies>
			<Policy user="root">
				<Attributes check="all" ><!-- all, any or none -->
					<Attribute name="cn" value="John" />
				</Attributes>
			</Policy>
			<Policy user="infoadmin">
				<Attributes check="any" ><!-- all, any or none -->
					<Attribute name="cn" value="John" />
					<Attribute name="sn" value="McCain" />
				</Attributes>
			</Policy>
		</Policies>
	</SSHServer>
*/
class Policy {
	private $user;
	private $timeout;
	private $conditionAttrs;
	private $attrs;
	
	public function __construct($xmlElem = "") {
		$this->user="";
		$this->timeout=1;
		$this->conditionAttrs="none";
		$this->attrs=array();
		
		if (!is_string($xmlElem)) {
			$this->loadFromXML($xmlElem);
		}
	}
	
	private function loadFromXML($xmlElem) {
		$this->user = $xmlElem["user"];
		$this->timeout = $xmlElem["timeout"];
		if (count($xmlElem->Attributes)>0) {
			$this->conditionAttrs = $xmlElem->Attributes["check"];
			foreach ($xmlElem->Attributes->Attribute as $attrXML) {
				$this->addAttribute((string) $attrXML["name"],(string) $attrXML["value"]);
			}
		}
	}
	
	public function setUser($user) {
		$this->user = $user;
	}
	
	public function getUser() {
		return $this->user;
	}
	
	public function setTimeout($timeout) {
		$this->timeout = $timeout;
	}
	
	public function getTimeout() {
		return $this->timeout;
	}
	
	public function setCondition($condition) {
		$this->conditionAttrs = $condition;
	}
	
	public function getCondition() {
		return $this->conditionAttrs;
	}
	
	public function addAttribute($name,$value) {
		$this->attrs[$name] = $value;
	}
	
	public function delAttribute($name) {
		unset($this->attrs[$name]);
	}
	
	public function getAttributes() {
		return $this->attrs;
	}
	
	public function checkPolicy($userAttrs) {
		$matched = 0;
		foreach ($this->getAttributes() as $key => $attr) {
			if (in_array($key, array_keys($userAttrs))) {
				if (in_array($attr, $userAttrs[$key])) {
					$matched++;
				}
			}
		}
		error_log($matched);
		error_log($this->conditionAttrs);
		if (strcmp($this->conditionAttrs,"none")==0&&$matched==0) {
			return true;
		}
		else if (strcmp($this->conditionAttrs,"any")==0&&$matched>0) {
			return true;
		}
		else if (strcmp($this->conditionAttrs,"all")==0&&$matched==count($this->getAttributes())) {
			return true;
		}
		else {
			return false;
		}
	}
}
?>